; routines to count the number of records in a file
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
*
; get the total nr of records for this file
; parameters
p.id    equ     $4      ; bufferid or indexid (long word, optional)
p.ret   equ     $c      ; return nr of records (long word), has to be passed
; errors
; itnf  buffer- or indexid invalid
cod_CNTA xsub
        regsave a1/a3-a5
        move.l  a1,a5           ; put it in a safe place
        tst.w   p.id-4(a5)      ; is the parameter given
        bne.s   a_nodef         ; yep -> don't use default
        xjsr    getbuff         ; default buffer for this job in d0
        move.l  d0,a4           ; bufferid in a4
        xjsr    testbid         ; now, is it a valid buffer ?
        bne.s   a_end           ; no -> don't do anything
        bra.s   a_ret           ; return asked value
a_nodef move.l  p.id(a5),a4     ; get the given id
        move.l  a4,d0
        xjsr    testbid         ; is it a buffer id
        beq.s   a_ret           ; return asked value
        move.l  p.id(a5),a3     ; oops, can it be an index id
        move.l  a3,d0
        xjsr    testiid         ; check it out
        bne.s   a_end           ; who the hell did the parameter parsing ?
        move.l  i_buffer(a3),a4 ; buffer for this index
a_ret   move.l  p.ret(a5),a1    ; place to put return value
        move.l  b_file(a4),a4   ; get file for this buffer
        move.l  f_count(a4),(a1); fill it in
        moveq   #0,d0
a_end
        subend
*
; get the nr of records in this index
; parameters, idem CNTA, but default index used if bufferid passed
cod_CNTR xsub
        regsave d7/a1-a5
        move.l  a1,a5           ; put it in a safe place
        tst.w   p.id-4(a5)      ; is the parameter given
        bne.s   r_nodef         ; yep -> don't use default
        xjsr    getbuff         ; default buffer for this job in d0
        move.l  d0,a4           ; bufferid in a4
        xjsr    testbid         ; now, is it a valid buffer ?
        bne.s   r_end           ; no -> don't do anything
r_buff  move.l  b_file(a4),a2   ; file id
        move.l  f_count(a2),d7  ; total nr of records
        tst.l   b_dindex(a4)    ; is there a default index
        beq.s   r_ret           ; no, return total nr of records
        move.l  b_index(a4),a3  ; indexid
        move.l  a3,d0
        xjsr    testiid         ; is it valid ??
        bne.s   r_ret           ; no -> take all records count
        move.l  i_count(a3),d7  ; nr of records in this index
        bra.s   r_ret           ; return asked value
r_nodef move.l  p.id(a5),a4     ; get the given id
        move.l  a4,d0
        xjsr    testbid         ; is it a buffer id
        beq.s   r_buff          ; return asked value
        move.l  p.id(a5),a3     ; oops, can it be an index id
        move.l  a3,d0
        xjsr    testiid         ; check it out
        bne.s   r_end           ; who the hell did the parameter parsing ?
        move.l  i_count(a3),d7  ; nr of records in this index
r_ret   move.l  p.ret(a5),a1    ; place to put return value
        move.l  d7,(a1)         ; fill it in
        moveq   #0,d0
r_end
        subend
*
; get the nr of fields for this file, disregarding the MEMO field
; parameters
;p.id    equ     $4      ; bufferid (long word, optional)
;p.ret   equ     $c      ; return nr of fields (word)
; errors
; itnf  bufferid invalid
cod_CNTF xsub
        regsave d1/a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        move.l  b_file(a4),a4   ; we only need the fileid

        ; just count the fields
        moveq   #0,d0           ; nr of fields
        move.w  #254,d1         ; loop counter
        lea     f_fields(a4),a4 ; start of field data
lp      adda.w  #18,a4          ; check next fields
        tst.w   (a4)            ; is this field implemented
        beq.s   nofld           ; no -> try the next one
        addq.w  #1,d0           ; one more field for this file
nofld   dbf     d1,lp           ; do we have to test another field ?

        ; fill in the return value
        move.l  p.ret(a5),a1    ; place to put return value
        move.w  d0,(a1)         ; fill it in
        moveq   #0,d0           ; no error
codend
        subend
;
        end
