; index save
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
        include win1_inc_keys_err
        include win1_inc_qdos_sms
        include win1_inc_qdos_ioa
        include win1_inc_keys_sys
        include win1_inc_keys_ext_thg
*
; index save
; parameters
p.id    equ     $4      ; buffer id or indexid (long word, optional)
p.name  equ     $c      ; name of file (opt, string or substring)
p.dev   equ     $14     ; device of file (opt, string or substring)
p.over  equ     $18     ; overwrite file ? (uword, 0-> no overwrite)
; errors
; itnf  buffer or indexid not found
; rdo   oops, read only medium, and no overwrite
; drfl  drive full
; fex   file already exists
; ... any other file error
; any other file-error
cod_ISAV xsub
        regsave d1-d7/a0-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        move.l  d0,a2           ; or it can be the indexid
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   tindex          ; if not -> try it as an index
        move.l  b_dindex(a4),a2 ; take default index
tindex  move.l  a2,d0
        beq     codend          ; no index -> nothing to do
        xjsr    testiid         ; see if it is valid
        bne     codend
        move.l  i_buffer(a2),a4 ; then this is the buffer id

        ; now we copy the filename
        lea     i_name(a2),a3   ; place to fill in file-name
        moveq   #0,d0           ; clear error for return
        move.w  p.name-4(a5),d1 ; type of parameter
        beq.s   enam            ; not specified -> don't copy
        btst    #thp..str,d1    ; string parameter ?
        beq.s   codnstr         ; no -> ..
        move.l  p.name(a5),a1   ; ptr to name
        move.w  (a1)+,d1        ; string length
        beq.s   enam            ; if zero -> no string to copy
        bra.s   codcps          ; copy string
codnstr btst    #thp..sst,d1    ; sub-string parameter ?
        beq.s   enam
        move.w  p.name-2(a5),d1 ; string length
        beq.s   enam            ; if zero -> no string to copy
        move.l  p.name(a5),a1   ; ptr to name
codcps
        cmp.w   #32,d1          ; check that name is not too long
        bmi.s   codlok          ; not too long
        move.w  #32,d1          ; name max 32 chars
codlok  move.w  d1,(a3)+        ; fill in length
        subq.w  #1,d1           ; prepare for dbf
codcpy  move.b  (a1)+,(a3)+     ; copy a char
        dbf     d1,codcpy       ; and the next one ?...
enam
        ; now we copy the devicename
        lea     i_device(a2),a3 ; place to fill in file-name
        moveq   #0,d0           ; clear error for return
        move.w  p.dev-4(a5),d1  ; type of parameter
        beq.s   edev            ; not specified -> don't copy
        btst    #thp..str,d1    ; string parameter ?
        beq.s   ccdnstr         ; no -> ..
        move.l  p.dev(a5),a1    ; ptr to name
        move.w  (a1)+,d1        ; string length
        beq.s   edev            ; if zero -> no string to copy
        bra.s   ccdcps          ; copy string
ccdnstr btst    #thp..sst,d1    ; sub-string parameter ?
        beq.s   edev
        move.w  p.dev-2(a5),d1  ; string length
        beq.s   edev            ; if zero -> no string to copy
        move.l  p.dev(a5),a1    ; ptr to name
ccdcps
        cmp.w   #32,d1          ; check that name is not too long
        bmi.s   ccdlok          ; not too long
        move.w  #32,d1          ; name max 32 chars
ccdlok  move.w  d1,(a3)+        ; fill in length
        subq.w  #1,d1           ; prepare for dbf
ccdcpy  move.b  (a1)+,(a3)+     ; copy a char
        dbf     d1,ccdcpy       ; and the next one ?...
edev

        mutex                   ; enter supervisor mode, prevent stack from moving about
        suba.w  #70,sp          ; reserve area for filename
openlp
        bsr     ginam
        moveq   #myself,d1
        moveq   #ioa.knew,d3    ; new file
        tst.b   p.over+3(a5)    ; overwrite ?
        beq.s   nover           ; no -> ...
        moveq   #ioa.kovr,d3
nover   moveq   #ioa.open,d0
        trap    #do.ioa         ; open the file
        cmpi.l  #err.fdnf,d0    ; let's see if we can add DATAD$
        bne.s   opened
        ; ok, can we fill in DATAD$ as device ??
        tst.w   i_device(a2)    ; is there already a device
        bne.s   opened          ; well, forget it
        ; so get the data device, and fill it in
        moveq   #sms.info,d0    ; get system information
        trap    #do.sms2
        move.l  sys_datd(a0),a1 ; DATA_USE device in a1
        lea     i_device(a2),a0
        moveq   #err.fdnf,d0    ; restore error just in case
        move.w  (a1)+,d1        ; length
        move.w  d1,(a0)+
        beq     ahum
        subq.w  #1,d1           ; prepare for dbf
gfdat   move.b  (a1)+,(a0)+     ; copy a char
        dbf     d1,gfdat        ; and the next one ?...
        ; try opening again
        bra     openlp
opened  tst.l   d0              ; was there an error ??
        bmi     ahum            ; you must be kidding
        ; when we get here, the file is opened and the chid is in d0

        ; start building the file data
        move.l  sp,a1
        move.l  #'DATA',(a1)+
        move.l  #'desi',(a1)+
        move.l  #'gn i',(a1)+
        move.l  #'ndex',(a1)+
        move.w  #'00',(a1)+
        move.w  i_len(a2),(a1)+
        move.l  sp,a1           ; header to send
        moveq   #20,d2          ; nr of bytes to send
        xjsr    iob_smul
        bmi.s   clos            ; oops...
        lea     i_sort(a2),a1
        move.l  #200,d2         ; standard sort order
        xjsr    iob_smul
        bmi.s   clos

        ; and now start writing all the index linkages to the file
        ; we do this by running through all areas and saving all records which we found
        ; this is a recordlinkage with recordid <>-1
        move.l  i_area(a2),d1   ; place in list of areas
        beq.s   clos            ; no records to save -> ..
arealp  move.l  d1,a5
        moveq   #99,d7          ; nr of linkages to run through
        lea     4(a5),a4        ; first record linkage
nxtrl   cmpi.l  #-1,il_id(a4)   ; linkage used ??
        beq.s   endrl

        ; now send the actual index linkage
        ; first a header
        lea     il_id(a4),a1    ; start of area to send
        moveq   #4,d2
        add.w   i_len(a2),d2
        add.w   i_len(a2),d2    ; len of area to send
        xjsr    iob_smul
        bmi.s   clos

endrl   adda.w  #il.len,a4      ; start of next linkage
        adda.w  i_len(a2),a4
        adda.w  i_len(a2),a4
        dbf     d7,nxtrl

        move.l  (a5),d1         ; next area ??
        bne     arealp          ; if there is one

clos    ; now close this channel
        move.l  d0,d7
        moveq   #ioa.clos,d0
        trap    #do.ioa
        move.l  d7,d0

ahum    adda.w  #70,sp          ; release ssp
        endmutex                ; hehe, all done
codend  subend
;
; routine to build the filename on stack (start addr returned in a0)
; there is an equivalent routine for file (gnam), this is for index
ginam   xsub    ; build medium-filename
        lea     4(sp),a0        ; and put it in a0
        lea     i_device(a2),a1 ; start of device
        move.w  (a1)+,d1        ; length
        move.w  d1,(a0)+
        beq.s   ndev
        subq.w  #1,d1           ; prepare for dbf
gfdev   move.b  (a1)+,(a0)+     ; copy a char
        dbf     d1,gfdev        ; and the next one ?...
ndev    lea     4(sp),a3
        lea     i_name(a2),a1   ; start of device
        move.w  (a1)+,d1        ; length
        beq.s   nnam
        add.w   d1,(a3)+
        subq.w  #1,d1           ; prepare for dbf
gfnam   move.b  (a1)+,(a0)+     ; copy a char
        dbf     d1,gfnam        ; and the next one ?...
nnam    ; now see if we have to add _ddf
        cmpi.b  #'_',-4(a0)     ; is there a _ddf
        bne.s   add_ddf
        cmpi.b  #'d',-3(a0)
        beq.s   ext3
        cmpi.b  #'D',-3(a0)
        bne.s   add_ddf
ext3    cmpi.b  #'d',-2(a0)
        beq.s   ext4
        cmpi.b  #'D',-2(a0)
        bne.s   add_ddf
ext4    cmpi.b  #'i',-1(a0)
        beq.s   open
        cmpi.b  #'I',-1(a0)
        beq.s   open
add_ddf move.b  #'_',(a0)+      ; add _ddf to the filename
        move.b  #'d',(a0)+
        move.b  #'d',(a0)+
        move.b  #'i',(a0)+
        lea     4(sp),a0
        add.w   #4,(a0)
open    lea     4(sp),a0        ; start of filename
        rts
;
        end
