; index update (rebuild index)
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
*
; index update/ (re)build index
; records which are being edited by another buffer for this file will not be included in this index
; routine to build the actual indextree, or delete old and re-build
; the index data may have changed before this
; this is usefull as indexes can become useless if the records in the file have changed too much
; as deleted records stay in this list,
; and changed records, will stay in the list the old way
; parameters
p.id    equ     $4      ; buffer id or indexid (long word, optional)
; errors
; imem  out of memory
; ipar  something about the sort data is impossible
; any error returned by GREC (getrec)
cod_IUPD xsub
        regsave d1-d7/a0-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        move.l  d0,a2           ; or it can be the indexid
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   tindex          ; if not -> try it as an index
        move.l  b_dindex(a4),a2 ; take default index
tindex  move.l  a2,d0
        beq     codend          ; no index -> nothing to do
        xjsr    testiid         ; see if it is valid
        bne     codend
        move.l  i_buffer(a2),a4 ; then this is the buffer id
        move.l  b_file(a4),a3   ; we need the fileid

        ; first delete the old tree
        clr.l   i_free(a2)      ; remove free list
        clr.l   i_top(a2)       ; and tree
        rellist i_area(a2)      ; and areas with linkages
        clr.l   i_count(a2)     ; so no records yet

        ; now make sure these structures are filled in properly
        xjsr    indexlen        ; fill in i_len and i_fti, a2=indexid, a3=fileid, a4=bufferid
        bne     codend          ; the parameters need to be correct

        ; now "run" through all the records, and create the sort tree
        ; corrupts a4/a5/d7 (have to be preserved during "run")
        move.l  f_area(a3),d1   ; place in list of areas
        beq     runend          ; no records to sort -> ..
run     move.l  d1,a5
        moveq   #99,d7          ; nr of linkages to run through
        lea     4(a5),a4        ; first record linkage
runlp   cmpi.l  #-1,rl_id(a4)   ; linkage used ??
        beq.s   runnxt

        ; NOW WE HAVE TO LINK THIS RECORD IN
        ; we need an empty index linkage
        move.l  i_free(a2),d1   ; is there one ?
        bne.s   gotfree         ; yes -> ...
        xjsr    getifree        ; get free index linkages
        bne     codend          ; oops, OUT OF MEMORY
gotfree ; now use one of these links
        ; get the record in the buffer !!
        move.l  rl_id(a4),d1    ; recordid
        move.l  a4,-(sp)
        move.l  i_buffer(a2),a4 ; we need the bufferid
        xjsr    GREC            ; get the record
        move.l  (sp)+,a4
        bne.s   runnxt

        xjsr    recfilt         ; is this record visible ?
        beq.s   runnxt          ; no it isn't -> ..

        ; fill in the index linkage
        move.l  a4,-(sp)        ; keep a4 for "run"
        move.l  i_buffer(a2),a4
        move.l  i_free(a2),a1
        xjsr    fillil          ; needs a1 index linkage, a4 bufferid, a2 index
        move.l  (sp)+,a4        ; restore a4 for "run"

        ; now we have to link it
        ; linkind is recursive routine to link a record in the index
linkregs reg    d6/a0/a2/a5
        movem.l linkregs,-(sp)
        move.w  i_len(a2),d3    ; length of compare block
        subq.w  #1,d3
        move.w  i_sort+i_cmp(a2),d6     ; first compare level
        move.l  i_free(a2),a1
        move.l  il_next(a1),i_free(a2)  ; unlink the item
        lea     i_top(a2),a0
        move.l  a0,-(sp)        ; head pointer of tree
        move.l  a1,a2           ; linkage has to be in a2
        moveq   #0,d2           ; start with false
        xjsr    linkind
        adda.w  #4,sp           ; clean up stack
        move.l  a2,a1           ; keep linkage for possible re-link
        movem.l (sp)+,linkregs

        ; and we have an extra record in the index
        addq.l  #1,i_count(a2)
        tst.l   d0
        beq.s   runnxt

        ; we were unable to link it in
        linkin  i_free(a2),a1   ; re-link index linkage
        ; and we DON'T have an extra record in the index
        subq.l  #1,i_count(a2)

runnxt  adda.w  #rl.len,a4      ; start of next linkage
        dbf     d7,runlp

        move.l  (a5),d1         ; next area ??
        bne     run             ; if there is one
runend  move.l  i_buffer(a2),a4 ; bufferid

        tst.b   f_file(a3)      ; was it file based
        beq.s   finish
        move.l  f_chid(a3),a0   ; channel id
        xjsr    iof_flsh
finish  moveq   #0,d0
codend
        subend
;
        end
