; start using a file, the file can already be in memory,
; or has to be loaded from the given device
; if not found, the data_use device will be tried
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
        include win1_inc_keys_err
        include win1_inc_qdos_sms
        include win1_inc_qdos_ioa
        include win1_inc_keys_sys
        include win1_inc_keys_ext_thg
*
; start using a file, the file can already be in memory,
; or has to be loaded from the given device
; if not found, the data_use device will be tried
; another buffer will be created to access the file
; the current record is a new one
; parameters
p.id    equ     $4      ; bufferid (optional)
p.name  equ     $c      ; name of file (string or substring)
p.dev   equ     $14     ; device of file (opt, string or substring)
p.rdo   equ     $18     ; read only ? (ubyte)
; errors
; imem  not enough memory
; fdnf  file or device not found
; isin  invalid syntax, this is not a DATAdesign file
; iexp  invalid expression, this DATAdesign file is too old
;       may be that one forgot to give a filename
; ...
; any other file-error
cod_USE xsub
        regsave d1-d7/a0-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        beq.s   start           ; no -> search name etc
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   start           ; if not -> error
        ; so create a new buffer which accesses the same file
        move.l  b_file(a4),a3   ; the fileid
        bra.s   gotfile

start   ; now we get the filename
        lea     f_name(a4),a2   ; place to fill in file-name
        moveq   #err.fdnf,d0    ; clear error for return
        move.w  p.name-4(a5),d1 ; type of parameter
        beq     codend          ; not specified -> don't copy
        btst    #thp..str,d1    ; string parameter ?
        beq.s   codnstr         ; no -> ..
        move.l  p.name(a5),a1   ; ptr to name
        move.w  (a1)+,d1        ; string length
        beq     codend          ; if zero -> no string to copy
        bra.s   codcps          ; copy string
codnstr btst    #thp..sst,d1    ; sub-string parameter ?
        beq     codend
        move.w  p.name-2(a5),d1 ; string length
        beq     codend          ; if zero -> no string to copy
        move.l  p.name(a5),a1   ; ptr to name
codcps  cmp.w   #32,d1          ; check that name is not too long
        bmi.s   codlok          ; not too long
        move.w  #32,d1          ; name max 32 chars
codlok
        xjsr    getflist        ; get first fid in list
        beq     loadit          ; none -> load it

        ; now search for a file with given name
namelp  move.l  d0,a3           ; fid in a3
        lea     f_name(a3),a2   ; name in a2
        cmp.w   (a2)+,d1        ; same length ?
        bne     nxtname
        move.l  a1,a0           ; keep a1
        move.w  d1,d0           ; and d1
        subq.w  #1,d0           ; adjust to dbf
namtst  move.b  (a0)+,d3        ; compare it
        cmp.b   (a2)+,d3
        bne     nxtname         ; different -> try next fid
        dbf     d0,namtst       ; compare next character

        ; so we found the file
        ; now we have to create another buffer for it
        ; the fileid can be found in a3
gotfile move.l  #b.len,d1       ; length of buffer linkage
        xjsr    getmem          ; get the memory for it (cleared)
        bne     codend
        move.l  a0,a4           ; keep it
        ; set flag
        move.l  #'DATA',b_flag(a4)
        move.l  #'desi',b_flag+4(a4)
        move.l  #'gn b',b_flag+8(a4)
        move.l  #'uffr',b_flag+12(a4)

        move.l  #1024,d1        ; length of actual buffer
        xjsr    getmem          ; get the memory for it (d1 is length allocated)
        bne.s   relbuff

        move.l  d1,b_mlen(a4)   ; fill in length of buffer memory
        move.l  a0,b_mem(a4)    ; ptr to buffer memory
        move.b  #1,b_new(a4)    ; we will start with a new record
        moveq   #sms.info,d0
        trap    #do.sms2        ; job id returned in d1
        move.l  d1,b_jobid(a4)
        linkin  f_buffer(a3),a4 ; link this buffer in
        move.l  a3,b_file(a4)   ; ptr to file this buffer uses
        move.b  p.rdo+3(a5),b_view(a4)  ; set whether this is a view onl buffer

        move.l  a4,d0           ; new buffer id
        xjsr    setbuff         ; make it default
        moveq   #0,d0           ; no error
        bra     codend
relbuff                         ; release buffer & file mem
        move.l  d0,d1           ; keep error code for a while
        move.l  a4,a0
        xjsr    relmem          ; release buffer
        move.l  d1,d0
        bra     codend

nxtname move.l  f_next(a3),d0   ; try next one
        bne     namelp          ; if any
loadit  ; ok, so we have to load the file from medium
        xjsr    newfile         ; create a file for it (bid in d0)
        bmi     codend          ; failed -> stop
        move.l  d0,a4           ; bufferid
        move.l  b_file(a4),a3   ; fileid

        ; fill in view status of buffer
        move.b  p.rdo+3(a5),b_view(a4)

        xjsr    getjid          ; get 'DATAdesign files' jobid
        move.l  d0,d6           ; and keep it in d6

        mutex                   ; prevent stack from shifting
        ; fill in filename
        lea     f_name(a3),a2
        move.w  d1,(a2)+        ; fill in length
        subq.w  #1,d1           ; prepare for dbf
codcpy  move.b  (a1)+,(a2)+     ; copy a char
        dbf     d1,codcpy       ; and the next one ?...
enam
        ; now we copy the devicename
        lea     f_device(a3),a2 ; place to fill in file-name
        moveq   #0,d0           ; clear error for return
        move.w  p.dev-4(a5),d1  ; type of parameter
        beq.s   edev            ; not specified -> don't copy
        btst    #thp..str,d1    ; string parameter ?
        beq.s   ccdnstr         ; no -> ..
        move.l  p.dev(a5),a1    ; ptr to name
        move.w  (a1)+,d1        ; string length
        beq.s   edev            ; if zero -> no string to copy
        bra.s   ccdcps          ; copy string
ccdnstr btst    #thp..sst,d1    ; sub-string parameter ?
        beq.s   edev
        move.w  p.dev-2(a5),d1  ; string length
        beq.s   edev            ; if zero -> no string to copy
        move.l  p.dev(a5),a1    ; ptr to name
ccdcps
        cmp.w   #32,d1          ; check that name is not too long
        bmi.s   ccdlok          ; not too long
        move.w  #32,d1          ; name max 32 chars
ccdlok  move.w  d1,(a2)+        ; fill in length
        subq.w  #1,d1           ; prepare for dbf
ccdcpy  move.b  (a1)+,(a2)+     ; copy a char
        dbf     d1,ccdcpy       ; and the next one ?...
edev
        suba.w  #70,sp          ; reserve area for filename and other small work
        xjsr    gnam            ; form the filename

        move.l  d6,d1           ; jobid
        moveq   #ioa.kexc,d3
        moveq   #ioa.open,d0
        trap    #do.ioa         ; open the file
        cmpi.l  #err.fdnf,d0    ; let's see if we can add DATAD$
        bne.s   opened
        ; ok, can we fill in DATAD$ as device ??
        ; so get the data device, and fill it in
        moveq   #sms.info,d0    ; get system information
        trap    #do.sms2
        move.l  sys_datd(a0),a1 ; DATA_USE device in a1
        lea     f_device(a3),a0
        moveq   #err.fdnf,d0    ; restore error just in case
        move.w  (a1)+,d1        ; length
        move.w  d1,(a0)+
        beq     ahum
        subq.w  #1,d1           ; prepare for dbf
gfdat   move.b  (a1)+,(a0)+     ; copy a char
        dbf     d1,gfdat        ; and the next one ?...
        ; try opening again
        xjsr    gnam            ; form the filename

        move.l  d6,d1           ; jobid
        moveq   #ioa.kexc,d3
        moveq   #ioa.open,d0
        trap    #do.ioa         ; open the file
opened  tst.l   d0              ; was there an error ??
        bmi     release         ; you must be kidding
        move.l  a0,f_chid(a3)   ; fill in channelid in case of file based
        ; when we get here, the file is opened and the chid is in d0

        ; test the file heading
        move.l  sp,a1           ; start of buffer
        moveq   #18,d2          ; nr of bytes to fetch
        xjsr    iob_fmul
        bmi.s   close           ; please no...
        moveq   #err.isyn,d0    ; assume no DATAdesign file
        move.l  sp,a1
        cmp.l   #'DATA',(a1)+
        bne.s   close
        cmp.l   #'desi',(a1)+
        bne.s   closeold
        cmp.w   #'gn',(a1)+
        bne.s   close
        moveq   #err.iexp,d0    ; ok, it is a DATAdesign file, but is it v3 ??
        cmp.l   #' fil',(a1)+
        bne.s   close
        cmp.l   #'e 00',(a1)+
        bne.s   close

        ; well, at least the filename was completely valid
        move.l  sp,a1           ; start of buffer
        moveq   #8,d2           ; nr of bytes to fetch
        xjsr    iob_fmul
        bmi.s   close
        move.l  sp,a1           ; fill in part of the file data
        move.l  (a1)+,f_lstrid(a3)
        move.b  (a1)+,f_lstfid(a3)
        move.b  (a1)+,f_file(a3)
        move.w  (a1)+,f_irsp(a3)
        lea     f_order1(a3),a1 ; start of buffer
        move.l  #512,d2         ; fetch sort order data
        xjsr    iob_fmul
        bmi.s   close
        lea     f_fields(a3),a1 ; start of buffer
        move.l  #4608,d2        ; fetch field data
        xjsr    iob_fmul
        bpl.s   cont
; in case of problems, release the file we started, and close
close   move.l  f_chid(a3),a0   ; restore channel id
        move.l  d0,d7           ; preserve error
        moveq   #ioa.clos,d0    ; close the lot
        trap    #do.ioa
        move.l  d7,d0
release
        move.l  d0,d7           ; preserve error
        adda.w  #70,sp          ; release ssp
        endmutex                ; back to user mode
        xjsr    unuse           ; release the file, bufferid in a4
        move.l  d7,d0
        subend

closeold        ; check if intermidiate DATAdesign file
        cmp.l   #'dsgn',-4(a1)
        bne     close
        cmp.w   #'01',(a1)
        bmi     close
        cmp.w   #'02',(a1)
        bgt     close
        moveq   #err.iexp,d0    ; ok, it is a DATAdesign file, but is it v3 ??
        bra     close

; see if we have to load this file memory, or disk-based
cont    tst.b   f_file(a3)      ; testing
        beq.s   continue        ; we need it memory-based
        adda.w  #70,sp          ; clean up stack
        bsr     loaddisk        ; load from disk a0/a3/a4 set
        endmutex
        subend


        xdef    loadfile
loadfile        ; move a disk based file to memory
                ; a3 (fid) and a4 (bid) have to be set
        movem.l d1-d7/a0-a5,-(sp)
        clr.b   f_file(a3)      ; make it memory based
        xjsr    getjid          ; get 'DATAdesign files' jobid
        move.l  d0,d6           ; and keep it in d6
        mutex                   ; we have to be in supervisor mode
        ; we first have to release the record linkages
        rellist f_area(a3)
        clr.l   f_top(a3)
        clr.l   f_free(a3)
        clr.l   f_count(a3)     ; and we removed all records
        suba.w  #70,sp          ; and we need some stackspace
        move.l  f_chid(a3),a0   ; get channel id
        move.l  #5146,d1
        xjsr    iof_posa        ; position file absolute
        bpl.s   continue
        moveq   #0,d0
        bra     ahum

continue        ; now we start the actual loading of the file
        xjsr    iob_fbyt        ; get a byte
        cmpi.l  #err.eof,d0     ; end of file ?
        beq     endit           ; no problem, it's done
        tst.l   d0
        bne     close           ; oops, major error
        cmpi.b  #'R',d1         ; start of another record ??
        bne.s   continue        ; try again, to reach the start of a record

        ; so we have a record, get all record data
        xjsr    iob_fbyt        ; get mark status in d1
        bmi     close
        move.l  sp,a1           ; start of buffer
        moveq   #12,d2          ; nr of bytes
        xjsr    iob_fmul
        bmi     close
        move.w  d1,20(sp)

        ; we now need an empty record linkage
        move.l  f_free(a3),d1   ; is there one ?
        bne.s   gotfree         ; yes -> ...

        ; allocate some memory for 100 new record linkages
        move.l  #rl.100,d1      ; amount of mem for it
        xjsr    getsmem         ; get the memory
        bne     ahum            ; imem -> ..

        move.l  f_area(a3),(a0) ; link the area in
        move.l  a0,f_area(a3)
        adda.w  #4,a0

        moveq   #99,d1          ; nr of links
lnkloop move.l  f_free(a3),(a0) ; link in
        move.l  a0,f_free(a3)
        move.l  #-1,rl_id(a0)   ; and mark as unused
        adda.w  #rl.len,a0      ; go to next one
        dbf     d1,lnkloop      ; and link next one

        ; now use one of these links
gotfree
        ; so get the new buffer memory
        move.l  8(sp),d1        ; get record length
        add.l   #r_fld,d1       ; add header length
        xjsr    getsmem         ; get the memory for it
        bne     close           ; so, we're out of memory are we ??

        sub.l   #r_fld,d1       ; length of reserved space without header length
        move.l  d1,r_space(a0)  ; length of reserved space
        move.l  (sp),r_id(a0)   ; fill in recordid
        move.w  20(sp),d1
        move.b  d1,r_mark(a0)   ; mark status
        move.l  8(sp),r_len(a0) ; record len
        move.l  4(sp),r_date(a0); record date

        move.l  f_free(a3),a2   ; get the linkage
        move.l  (a2),f_free(a3) ; unlink it from the free-list
        ; now fill it in (partially)
        move.l  (sp),rl_id(a2)  ; fill in recordid
        move.l  a0,rl_pos(a2)   ; fill in ptr to record
        clr.b   rl_edit(a2)     ; this record is not being edited

        ; now we have to link it and fill in the record (preserve a2 during linking)
        ; linkin is recursive routine to link a record in
        ; ptr to list: on stack, a2 linkage block, d2 boolean
        adda.w  #70,sp          ; clean up stack to prevent overflow
        lea     f_top(a3),a0
        move.l  a0,-(sp)        ; head pointer of tree
        moveq   #0,d2           ; start with false
        xjsr    linkin
        suba.w  #66,sp          ; clean up stack, but also re-allocate the stack space

        ; and we have an extra record in the file
        addq.l  #1,f_count(a3)

        ; fill in the record (recordlinkage in a2)
        move.l  f_chid(a3),a0   ; restore channel id
        move.l  rl_pos(a2),a2   ; start of actual record
        move.l  r_len(a2),d2    ; recordlen
        lea     r_fld(a2),a1    ; start of actual record
        xjsr    iob_fmul
        bmi     close

        ; now search for the next record !!
        bra     continue

endit   adda.w  #70,sp
        endmutex
        moveq   #ioa.clos,d0    ; close the lot
        trap    #do.ioa
        bra.s   codend
ahum    adda.w  #70,sp          ; release ssp
        endmutex                ; hehe, all done
codend  subend
;

; routine to load a file disk based
; also sets the fileid, it being disk based etc
; a0 (chid), a3 (fid), a4 (bid) have to be set
; has to be called from supervisor with an empty stack
loaddisk xsub
        move.l  a0,f_chid(a3)   ; fill in channelid
        move.b  #1,f_file(a3)   ; the file is disk-based (of course)
        suba.w  #20,sp          ; and we need some stackspace
        move.l  #5146,d1        ; current filepos
        xjsr    iof_posa        ; position file absolute, to start of all
        bmi     ld_stop         ; nothing to load

ld_cont         ; now we start the actual loading of the file
        xjsr    iob_fbyt        ; get a byte
        cmpi.l  #err.eof,d0     ; end of file ?
        beq     ld_stop         ; no problem, it's done
        tst.l   d0
        bne     ld_end          ; oops, major error
        cmpi.b  #'R',d1         ; start of another record ??
        bne.s   ld_cont         ; try again, to reach the start of a record

        ; now find out the fileposition for this record
        moveq   #0,d1           ; no position change
        xjsr    iof_posr
        move.l  d1,d7
        subq.l  #1,d7           ; position of this record

        ; so we have a record, get record data
        xjsr    iob_fbyt        ; skip mark status
        bmi     ld_end
        move.l  sp,a1           ; start of buffer
        moveq   #12,d2          ; nr of bytes
        xjsr    iob_fmul
        bmi     ld_end

        ; we now need an empty record linkage
        move.l  f_free(a3),d1   ; is there one ?
        bne.s   ld_free         ; yes -> ...

        ; allocate some memory for 100 new record linkages
        move.l  #rl.100,d1      ; amount of mem for it
        xjsr    getsmem         ; get the memory
        bne.s   ld_end          ; imem -> ..

        move.l  f_area(a3),(a0) ; link the area in
        move.l  a0,f_area(a3)
        adda.w  #4,a0

        moveq   #99,d1          ; nr of links
ld_rllp move.l  f_free(a3),(a0) ; link in
        move.l  a0,f_free(a3)
        move.l  #-1,rl_id(a0)   ; and mark as unused
        adda.w  #rl.len,a0      ; go to next one
        dbf     d1,ld_rllp      ; and link next one

        ; now use one of these links
ld_free
        move.l  f_free(a3),a2   ; get the linkage
        move.l  (a2),f_free(a3) ; unlink it from the free-list
        ; now fill it in (partially)
        move.l  (sp),rl_id(a2)  ; fill in recordid
        move.l  d7,rl_pos(a2)   ; fill in filepos of this record
        clr.b   rl_edit(a2)     ; this record is not being edited
        move.l  8(sp),d7        ; keep record len

        ; now we have to link it (preserve a2 during linking)
        ; linkin is recursive routine to link a record in
        ; ptr to list: on stack, a2 linkage block, d2 boolean
        adda.w  #20,sp          ; clean up stack to prevent overflow
        lea     f_top(a3),a0
        move.l  a0,-(sp)        ; head pointer of tree
        moveq   #0,d2           ; start with false
        xjsr    linkin
        suba.w  #16,sp          ; clean up stack, but also re-allocate the stack space

        ; and we have an extra record in the file
        addq.l  #1,f_count(a3)

        ; so adjust the filepointer
        move.l  f_chid(a3),a0   ; restore channel id
        move.l  d7,d1           ; record len
        xjsr    iof_posr        ; skip it
        beq     ld_cont         ; no error, no problem -> next record
        cmpi.l  #err.eof,d0     ; end of file ?
        bne.s   ld_end          ; no -> report error

ld_stop moveq   #0,d0           ; no error
ld_end  adda.w  #20,sp          ; release ssp
        subend
;
        end
